<?php


namespace XenGenTr\ResimliOneCikanKonular\Widget;

use XF\Widget\AbstractWidget;

class OneCikanlar extends AbstractWidget
{
	protected $defaultOptions = [
		'limit' => 5,
		'trim' => 200,
	];
	
	public function render()
	{
		$options = $this->options;

        $limit = \XF::options()->xgt_onecikankonu_konuliste_siniri;

		$onecikanRepo = $this->app->repository('XenGenTr\ResimliOneCikanKonular:OneCikan');

		$entries = $onecikanRepo->findOnecikan()->limit(max($limit * 2, 10))
			->where('Thread.discussion_state', 'visible');
		
		if (!$options['pages'] && $this->contextParams['page'] > 1)
		{
			return false;
		}

		if (!$onecikanlar = $entries->fetch())
		{
			return false;
		}
		
	    $onecikanlar = $onecikanlar->slice(0, $limit, true);

			$viewParams = [
			'onecikanlar' => $onecikanRepo->parseOnecikanlar($onecikanlar, $options['trim']),
		];

		return $this->renderer('xgt_OneCikan_Konular', $viewParams);
	}

	public function verifyOptions(\XF\Http\Request $request, array &$options, &$error = null)
	{
		$options = $request->filter([
			'limit' => 'uint',
			'trim' => 'uint',
		]);
		
		if ($options['limit'] < 1)
		{
			$options['limit'] = 1;
		}
		
		return true;
	}
}